/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TInputHelpparam.TInputHelpparamPath;
import de.ship.db.tables.TInputVariable.TInputVariablePath;
import de.ship.db.tables.records.TInputHelpRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputHelp extends TableImpl<TInputHelpRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_help</code>
     */
    public static final TInputHelp T_INPUT_HELP = new TInputHelp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputHelpRecord> getRecordType() {
        return TInputHelpRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_help.lastchange</code>.
     */
    public final TableField<TInputHelpRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_help.inputhelp</code>. id of input
     * help
     */
    public final TableField<TInputHelpRecord, Integer> INPUTHELP = createField(DSL.name("inputhelp"), SQLDataType.INTEGER.nullable(false), this, "id of input help");

    /**
     * The column <code>common_dd.t_input_help.inputhelp_descr</code>. language
     * key of input help
     */
    public final TableField<TInputHelpRecord, String> INPUTHELP_DESCR = createField(DSL.name("inputhelp_descr"), SQLDataType.CLOB.nullable(false), this, "language key of input help");

    /**
     * The column <code>common_dd.t_input_help.needed_params</code>. number of
     * helpparams needed for this inputhelper
     */
    public final TableField<TInputHelpRecord, Integer> NEEDED_PARAMS = createField(DSL.name("needed_params"), SQLDataType.INTEGER.defaultValue(DSL.field(DSL.raw("0"), SQLDataType.INTEGER)), this, "number of helpparams needed for this inputhelper");

    private TInputHelp(Name alias, Table<TInputHelpRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputHelp(Name alias, Table<TInputHelpRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_help</code> table reference
     */
    public TInputHelp(String alias) {
        this(DSL.name(alias), T_INPUT_HELP);
    }

    /**
     * Create an aliased <code>common_dd.t_input_help</code> table reference
     */
    public TInputHelp(Name alias) {
        this(alias, T_INPUT_HELP);
    }

    /**
     * Create a <code>common_dd.t_input_help</code> table reference
     */
    public TInputHelp() {
        this(DSL.name("t_input_help"), null);
    }

    public <O extends Record> TInputHelp(Table<O> path, ForeignKey<O, TInputHelpRecord> childPath, InverseForeignKey<O, TInputHelpRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_HELP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputHelpPath extends TInputHelp implements Path<TInputHelpRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputHelpPath(Table<O> path, ForeignKey<O, TInputHelpRecord> childPath, InverseForeignKey<O, TInputHelpRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputHelpPath(Name alias, Table<TInputHelpRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputHelpPath as(String alias) {
            return new TInputHelpPath(DSL.name(alias), this);
        }

        @Override
        public TInputHelpPath as(Name alias) {
            return new TInputHelpPath(alias, this);
        }

        @Override
        public TInputHelpPath as(Table<?> alias) {
            return new TInputHelpPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TInputHelpRecord> getPrimaryKey() {
        return Keys.PK_INPUT_HELP;
    }

    private transient TInputHelpparamPath _tInputHelpparam;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_helpparam</code> table
     */
    public TInputHelpparamPath tInputHelpparam() {
        if (_tInputHelpparam == null)
            _tInputHelpparam = new TInputHelpparamPath(this, null, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_INPUTHELP.getInverseKey());

        return _tInputHelpparam;
    }

    private transient TInputVariablePath _tInputVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_variable</code> table
     */
    public TInputVariablePath tInputVariable() {
        if (_tInputVariable == null)
            _tInputVariable = new TInputVariablePath(this, null, Keys.T_INPUT_VARIABLE__FK_INPUTVAR_INPUTHELP.getInverseKey());

        return _tInputVariable;
    }

    @Override
    public TInputHelp as(String alias) {
        return new TInputHelp(DSL.name(alias), this);
    }

    @Override
    public TInputHelp as(Name alias) {
        return new TInputHelp(alias, this);
    }

    @Override
    public TInputHelp as(Table<?> alias) {
        return new TInputHelp(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputHelp rename(String name) {
        return new TInputHelp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputHelp rename(Name name) {
        return new TInputHelp(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputHelp rename(Table<?> name) {
        return new TInputHelp(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelp where(Condition condition) {
        return new TInputHelp(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelp where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelp where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelp where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelp where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelp where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelp where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelp where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelp whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelp whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
